﻿    using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;

namespace binding
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private int foo = 0;
        // näiden täytyy olla public
        public Henkilo h1 = new Henkilo();
        public Henkilo h2 = new Henkilo();
        public Henkilo h3 = new Henkilo();

      
        public int testi
        {
            set { foo = value; }
            get { return foo; }
        }



        public int testi2
        {
            get { return (int)GetValue(testi2Property); }
            set { SetValue(testi2Property, value); }
        }

        // Using a DependencyProperty as the backing store for testi2.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty testi2Property =
            DependencyProperty.Register("testi2", typeof(int), typeof(MainWindow), new PropertyMetadata(0));

        


        public MainWindow()
        {
            InitializeComponent();
            // Nimi on alla määritelty dependency property johon xamlissa oleva label
            // viittaa. Painikkeella saadaan muutettua nimi ja nähdään miten myös labelin sisältö muuttuu
            Nimi = "Kukkuluuruu";
            label4.DataContext = this; // asetetaan labelin datakontekstiksi tämä luokka
        }

        // nimeäminen tehtävä juuri seuraavalla tavalla
        public static readonly DependencyProperty NimiProperty =
         DependencyProperty.Register(
           "Nimi",
           typeof(String), // propertyn tietotyyppi
           typeof(MainWindow), // luokka jossa property sijaitsee
           new FrameworkPropertyMetadata("John Doe",  // propertyn oletusarvo
              FrameworkPropertyMetadataOptions.None, // ei vaikuta luokan ulkoasuun
              new PropertyChangedCallback(OnValueChanged),  // kutsutaan propertyn arvon muuttumisen jälkeen
              new CoerceValueCallback(MuutaNimi))); // kutsutaan ennen propertyn arvon muutosta

        // seuraavat tehtävä juuri näin. Ei mitään tarkistuksien lisäämistä
        public String Nimi
        {
            get { return (String)GetValue(NimiProperty); }
            set { SetValue(NimiProperty, value); }
        }

        // tätä kutsutaan ennen laskurin muuttamista ja voidaan tässä vaiheessa
        // tehdä tarkistuksia ja muuttaa laskuriin asetettavaa arvoa
        private static object MuutaNimi(DependencyObject element, object value)
        {
            string nimi = (String)value;

            return nimi;
        }

        // Jos halutaan tehdä jotain arvon muuttuessa
        private static void OnValueChanged(DependencyObject obj, DependencyPropertyChangedEventArgs args)
        {
            // ei tarvita nyt. Jos haluttaisiin tehdä jotain Nimen muuttuessa niin se voitaisiin tehdä täällä
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Nimi = "Jahuuu!";
            h1.Nimi = "Uusi nimi";
            h2.Nimi = "Toinen nimi";
            h3.Nimi = "Kolmas nimi";
        }

        private void ikkuna_Loaded(object sender, RoutedEventArgs e)
        {
            // sidotaan labelien datacontextit haluttuihin objekteihin, jonka jälkeen bindaus alkaa toimi
            label1.DataContext = h1;
            label2.DataContext = h2;
            label3.DataContext = h3;

            h1.Nimi = "Tommi";
            h2.Nimi = "Kalle";
            h3.Nimi = "Ville";

        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {   

            testi++;
            testi2++;
        }
    }

    // kokeile poistaa perintä ja testaa sen jälkeen painiketta. Muutos ei päivity jos ei ole peritty INotifyPropertyChanged
    public class Henkilo : INotifyPropertyChanged
    {
        private string nimi = "Testi";
        // Declare the event 
        public event PropertyChangedEventHandler PropertyChanged;

        public Henkilo()
        {
        }

        public Henkilo(string value)
        {
            this.nimi = value;
        }

        public string Nimi
        {
            get { return nimi; }
            set
            {
                nimi = value;
                // Call OnPropertyChanged whenever the property is updated
                OnPropertyChanged(new PropertyChangedEventArgs("Nimi"));
            }
        }

        // Create the OnPropertyChanged method to raise the event 
        protected void OnPropertyChanged(PropertyChangedEventArgs e)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, e);
            }
        }
    }
}
